#include "../../../lib/std.mi"

#define CUSTOM_VOL_VAR MiniVol
#include "customvol.m"

#define CUSTOM_SEEK_VAR MiniSeek
#include "customseek.m"

#define LAYER_VIS_VAR MainVis
#include "layervis.m"

Global Map VolNSeekMap, VisMap;

Global int isEQOpen;

Class Layer HintLayer;
Class Button HintButton;

Global HintLayer Vol, VolGhost, Seek, SeekGhost, OnOffLayer, VisLayer, SwitchToLCD;
Global HintButton EQPush, PauseB, PlayB, SwitchToBVIS;

System.onScriptUnloading() {
 _MiniSeekShutdown();
 _MainVisShutdown();
}

System.onScriptLoaded() {
  Layout mainnormal = getContainer("Main").getLayout("Normal");

  Group lcdgroup = getContainer("Main").getLayout("Normal").getObject("main.lcd");
  Group pbgroup = getContainer("Main").getLayout("Normal").getObject("main.playback");
  Group eqgroup = getContainer("Main").getLayout("Normal").getObject("main.eq");
  Group bvisgroup = getContainer("Main").getLayout("Normal").getObject("main.bvis");

  VisLayer = bvisgroup.getObject("vislayer");

  SwitchToLCD = bvisgroup.getObject("switch");
  SwitchToBVis = lcdgroup.getObject("tobvis");

  EQPush = mainnormal.getObject("eqtoggle");
  OnOffLayer = eqgroup.getObject("onofflayer");
  isEQOpen = 0;

  PauseB = pbgroup.getObject("pause");
  PlayB = pbgroup.getObject("play");

  Vol = lcdgroup.getObject("volume");
  VolGhost = lcdgroup.getObject("volumefull");
  Seek = lcdgroup.getObject("seek");
  SeekGhost = lcdgroup.getObject("seekfull");

  VolNSeekMap = new Map;
  VolNSeekMap.loadMap("player.main.volnseek.map");
  VisMap = new Map;
  VisMap.loadMap("player.main.bvis.map");

  PauseB.hide();
  PlayB.hide();

  if (getLeftVUMeter() != 0) {
    PauseB.show();
  } 
  else {
    PlayB.show();
  }

  _MiniSeekInit( Seek , SeekGhost , VolNSeekMap);

  _MiniVolInit( Vol, VolGhost, VolNSeekMap);
  
  _MainVisInitCENTER(VisLayer, VisMap);
  _MainVisStart();

  bvisgroup.hide();
 _MainVisrefreshEQ.stop();
}

EQPush.onLeftClick() {

  Group EQSlider = getContainer("Main").getLayout("Normal").getObject("main.eq");

  if (isEQOpen == 1) {
	EQSlider.setTargetX(60);
	EQSlider.setTargetY(174);
	EQSlider.setTargetSpeed(1);

	EQSlider.gotoTarget();
        OnOffLayer.show();
  	isEQOpen = 0;
  } else {
	EQSlider.setTargetX(60);
	EQSlider.setTargetY(227);
	EQSlider.setTargetSpeed(1);

	eqSlider.gotoTarget();
        OnOffLayer.hide();
  	isEQOpen = 1;
  }
}

SwitchToLCD.onLeftButtonDown(int x, int y) {
 Group bvisgroup = getContainer("Main").getLayout("Normal").getObject("main.bvis");
 bvisgroup.hide();

 _MainVisrefreshEQ.stop();
}

SwitchToBVis.onLeftClick() {
 Group bvisgroup = getContainer("Main").getLayout("Normal").getObject("main.bvis");
 bvisgroup.show();

 _MainVisrefreshEQ.start();
}

System.onPlay() {
  PlayB.hide();
  PauseB.show();

  _MiniSeekTimer.start();
}

System.onStop() {
  PlayB.show();
  PauseB.hide();

  _MiniSeekTimer.stop();
  _MiniSeekTimer.onTimer();
}